package verify

import (
	"spaceofcheng/services/controllers"
	"spaceofcheng/services/models/model"
	"spaceofcheng/services/service/verify"
)

// CaseController 信息
type VerifyController struct {
	dao *verify.VerifyServ
	controllers.BaseController
}

// Constructor 初始化 Controller
// @Title Constructor
// @Description 初始化 Controller, 系统自动调用
func (c *VerifyController) Constructor() {
	c.dao = verify.NewVerifyServ(c.Context)
}
func (c *VerifyController) GetCustomerCourseDetailListById() {
	customerCourseId := c.GetString("customerCourseId")
	caseid := c.GetString("caseid")
	page, _ := c.GetInt("page")
	pageSize, _ := c.GetInt("pagesize")
	list, err := c.dao.GetCustomerCourseDetailById(customerCourseId, caseid, page, pageSize)
	if err != nil {
		c.ResponseError(err)
	}
	c.ResponseJSON(list)

}

func (c *VerifyController) GetCustomerCourseDetailListBytel() {
	caseid := c.GetString("caseid")
	tel := c.GetString("tel")
	page, _ := c.GetInt("page")
	pageSize, _ := c.GetInt("pagesize")
	list, err := c.dao.GetCustomerCourseDetailByTel(tel, caseid, page, pageSize)
	if err != nil {
		c.ResponseError(err)
	}
	c.ResponseJSON(list)

}

func (c *VerifyController) VerifyCourse() {
	customerCourseDetail := model.TaCustomerCourseDetail{}
	sysUser := c.Context.Get("user").(model.SysUser)
	userId := sysUser.UserId
	if err := c.ParseForm(&customerCourseDetail); err != nil {
		c.ResponseError(err)
	}
	customerCard, err := c.dao.GetCustomerCardByDetailId(customerCourseDetail.CustomerDetailId)
	if err != nil {
		c.ResponseError(err)
	}
	customerCourse, err := c.dao.GetCustomerCourseByDetailId(customerCourseDetail.CustomerDetailId)
	if err != nil {
		c.ResponseError(err)
	}
	if customerCard.VerifyStatus == "usable" {
		customerCard.VerifyStatus = "used"
		err := c.dao.UpdateCustomerCard(customerCard)
		if err != nil {
			c.ResponseError(err)
		}
	}
	err = c.dao.UpdateCustomerCourse(customerCourse)
	if err != nil {
		c.ResponseError(err)
	}
	err = c.dao.UpdateCustomerCourseDetail(&customerCourseDetail, userId)
	if err != nil {
		c.ResponseError(err)
	}
	c.ResponseJSON("核销成功")

}
